

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// Arduino UNO
//
////////////////////////
// ТЕЛЕЖКА НА ОДНОМ ВЕДУЩЕМ ПОВОРОТНОМ КОЛЕСЕ
//
#include <Servo.h>
#define V1  5
#define V2  6
#define V3  7
byte k = 180; //переменнная ШИМ
byte a; byte a0 = 128; //переменная текущего угла поворота и переменная начального угла поворота сервы
int n = 100; //переменная длительности между переключениями
long Y = 0; //переменная для хранения текущего времени
String inputString;// строки данных

////////////////////////////
Servo servo1;
void setup()
{
  Serial.begin(9600);
  pinMode(V1, OUTPUT);//выводы управления драйвером мотора
  digitalWrite(V1, LOW);
  pinMode(V2, OUTPUT);
  digitalWrite(V2, LOW);
  servo1.attach(V3);//вывод управления сервоприводом
  servo1.write(a0);// начальный поворот сервы
  a = a0;
}

void loop()
{
  CheckSerial();//ЖДЁМ ПОСТУПЛЕНИЯ КОМАНДЫ
}

/////////////////////////////////////////////////////////////////////////////////////////////////
//ФУНКЦИИ ПРИЁМА И ОБРАБОТКИ ДАННЫХ
void CheckSerial()
{
  //////////////////////////////////////////////////////////////////////////////
  while (Serial.available())//считываем строку данных пока они поступают
  {
    char inChar = (char)Serial.read();
    if (inChar == '\n')     //если окончание строки
    {
      MakeCmd();//обрабатываем её данной функцией
      break;
    }
    else inputString += inChar;// иначе удлиняем строку на один символ
  }
}
/////////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////
void MakeCmd()
{
  int y = inputString.length(); // присваиваем переменной у число символов в строке
  if (y < 1 || y > 1)return; //если их меньше 1 или больше, выходим из функции
  String cmd = inputString; // передаём строку другой переменной
  inputString = "";//"обнуляем переменную"

  if (cmd == "1") {
    analogWrite(V1, k);  //едем вперёд
    digitalWrite(V2, LOW);
  }
  if (cmd == "2") {
    analogWrite(V2, k-50);  //едем назад с плавным троганьем
    digitalWrite(V1, LOW);delay(750); analogWrite(V2, k);
  }
  if (cmd == "3") {
    SerPovorot();  //поворачиваем вправо
    analogWrite(V1, k);
    digitalWrite(V2, LOW);
    delay(100);
  }
  if (cmd == "4") {
    SerPovorot();  //поворачиваем влево
    analogWrite(V2, k);
    digitalWrite(V1, LOW);
    delay(100);
  }
  if (cmd == "A") {
    digitalWrite(V1, LOW);  // исходное состояние
    digitalWrite(V2, LOW);
    SerVozvrat();
  }

}

///////////////////////////////////////////////////////////////////////////////////////////////////////
void SerPovorot ()
{
  while (a > a0 - 100)
  {
    a--; servo1.write(a); delay(7);
  }
}
///////////////////////////////////////////////////////////////////////////////////////////////////////
void SerVozvrat ()
{
  while (a < a0)
  {
    a++; servo1.write(a); delay(10);
  }
}
///////////////////////////////////////////////////////////////////////////////////////////////////////

