////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// Arduino UNO
//
////////////////////////
// ТЕЛЕЖКА НА ОДНОМ ВЕДУЩЕМ ПОВОРОТНОМ КОЛЕСЕ
//
#include <Servo.h>
#define V3  7
#define V4  8

byte a; byte a0 = 120; //переменная текущего угла поворота и переменная начального угла поворота сервы
byte b0 = 78;//начальная скорость 0
String inputString;// строки данных

////////////////////////////
Servo servo1;
Servo servo4;
void setup()
{
  Serial.begin(9600);
  servo1.attach(V3);//вывод управления сервоприводом
  servo1.write(a0);// начальный поворот сервы
  servo4.attach(V4);//вывод управления сервоприводом-мотор-редуктором
  servo4.write(b0);// начальная скорость b0
  a = a0;
}

void loop()
{
  CheckSerial();//ЖДЁМ ПОСТУПЛЕНИЯ КОМАНДЫ
}

/////////////////////////////////////////////////////////////////////////////////////////////////
//ФУНКЦИИ ПРИЁМА И ОБРАБОТКИ ДАННЫХ
void CheckSerial()
{
  //////////////////////////////////////////////////////////////////////////////
  while (Serial.available())//считываем строку данных пока они поступают
  {
    char inChar = (char)Serial.read();
    if (inChar == '\n')     //если окончание строки
    {
      MakeCmd();//обрабатываем её данной функцией
      break;
    }
    else inputString += inChar;// иначе удлиняем строку на один символ
  }
}
/////////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////
void MakeCmd()
{
  int y = inputString.length(); // присваиваем переменной у число символов в строке
  if (y < 1 || y > 1)return; //если их меньше 1 или больше, выходим из функции
  String cmd = inputString; // передаём строку другой переменной
  inputString = "";//"обнуляем переменную"

  if (cmd == "1") {
      
  servo4.write(b0-30);//едем вперёд 
  }
  if (cmd == "2") {
    
    servo4.write(b0+10); //едем назад с плавным троганьем
    delay(750);
    servo4.write(b0+20); 
    
  }
  if (cmd == "3") {
    SerPovorot();  //поворачиваем вправо
    
    servo4.write(b0-10); 
    delay(200);
  }
  if (cmd == "4") {
    SerPovorot();  //поворачиваем влево
    servo4.write(b0+10); 
    delay(200);
  }
  if (cmd == "A") {
    
    servo4.write(b0); // исходное состояние
    SerVozvrat();
  }

}

///////////////////////////////////////////////////////////////////////////////////////////////////////
void SerPovorot ()
{
  while (a > a0 - 100)
  {
    a--; servo1.write(a); delay(7);
  }
}
///////////////////////////////////////////////////////////////////////////////////////////////////////
void SerVozvrat ()
{
  while (a < a0)
  {
    a++; servo1.write(a); delay(10);
  }
}
///////////////////////////////////////////////////////////////////////////////////////////////////////

